require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SPARC_SBI_H)) {
    eval 'sub _SPARC_SBI_H () {1;}' unless defined(&_SPARC_SBI_H);
    require 'asm/obio.ph';
    eval 'sub SBI_CID () {0x2800000;}' unless defined(&SBI_CID);
    eval 'sub SBI_CTL () {0x2800004;}' unless defined(&SBI_CTL);
    eval 'sub SBI_STATUS () {0x2800008;}' unless defined(&SBI_STATUS);
    eval 'sub SBI_CFG0 () {0x2800010;}' unless defined(&SBI_CFG0);
    eval 'sub SBI_CFG1 () {0x2800014;}' unless defined(&SBI_CFG1);
    eval 'sub SBI_CFG2 () {0x2800018;}' unless defined(&SBI_CFG2);
    eval 'sub SBI_CFG3 () {0x280001c;}' unless defined(&SBI_CFG3);
    eval 'sub SBI_STB0 () {0x2800020;}' unless defined(&SBI_STB0);
    eval 'sub SBI_STB1 () {0x2800024;}' unless defined(&SBI_STB1);
    eval 'sub SBI_STB2 () {0x2800028;}' unless defined(&SBI_STB2);
    eval 'sub SBI_STB3 () {0x280002c;}' unless defined(&SBI_STB3);
    eval 'sub SBI_INTR_STATE () {0x2800030;}' unless defined(&SBI_INTR_STATE);
    eval 'sub SBI_INTR_TID () {0x2800034;}' unless defined(&SBI_INTR_TID);
    eval 'sub SBI_INTR_DIAG () {0x2800038;}' unless defined(&SBI_INTR_DIAG);
    eval 'sub SBI_CFG_BURST_MASK () {0x1e;}' unless defined(&SBI_CFG_BURST_MASK);
    eval 'sub SBI2DEVID {
        local($sbino) = @_;
	    eval q((($sbino<<4)|2));
    }' unless defined(&SBI2DEVID);
    unless(defined(&__ASSEMBLY__)) {
	eval 'sub acquire_sbi {
	    local($devid,$mask) = @_;
    	    eval q({  &__asm__  &__volatile__ (\\"swapa [%2] %3, %0\\" : \\"=r\\" ($mask) : \\"0\\" ($mask), \\"r\\" ( &ECSR_DEV_BASE($devid) |  &SBI_INTR_STATE), \\"i\\" ( &ASI_M_CTL)); $mask; });
	}' unless defined(&acquire_sbi);
	eval 'sub release_sbi {
	    local($devid,$mask) = @_;
    	    eval q({  &__asm__  &__volatile__ (\\"sta %0, [%1] %2\\" : : \\"r\\" ($mask), \\"r\\" ( &ECSR_DEV_BASE($devid) |  &SBI_INTR_STATE), \\"i\\" ( &ASI_M_CTL)); });
	}' unless defined(&release_sbi);
	eval 'sub set_sbi_tid {
	    local($devid,$targetid) = @_;
    	    eval q({  &__asm__  &__volatile__ (\\"sta %0, [%1] %2\\" : : \\"r\\" ($targetid), \\"r\\" ( &ECSR_DEV_BASE($devid) |  &SBI_INTR_TID), \\"i\\" ( &ASI_M_CTL)); });
	}' unless defined(&set_sbi_tid);
	eval 'sub get_sbi_ctl {
	    local($devid,$cfgno) = @_;
    	    eval q({ \'int\'  &cfg;  &__asm__  &__volatile__ (\\"lda [%1] %2, %0\\" : \\"=r\\" ( &cfg) : \\"r\\" (( &ECSR_DEV_BASE($devid) |  &SBI_CFG0) + ($cfgno<<2)), \\"i\\" ( &ASI_M_CTL));  &cfg; });
	}' unless defined(&get_sbi_ctl);
	eval 'sub set_sbi_ctl {
	    local($devid,$cfgno,$cfg) = @_;
    	    eval q({  &__asm__  &__volatile__ (\\"sta %0, [%1] %2\\" : : \\"r\\" ($cfg), \\"r\\" (( &ECSR_DEV_BASE($devid) |  &SBI_CFG0) + ($cfgno<<2)), \\"i\\" ( &ASI_M_CTL)); });
	}' unless defined(&set_sbi_ctl);
    }
}
1;
