require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_AUDIOIO_H_)) {
    eval 'sub _AUDIOIO_H_ () {1;}' unless defined(&_AUDIOIO_H_);
    if(defined( &__KERNEL__) || !defined( &__GLIBC__) || ((defined(&__GLIBC__) ? &__GLIBC__ : 0) < 2)) {
	require 'linux/types.ph';
	require 'linux/time.ph';
	require 'linux/ioctl.ph';
    }
    eval 'sub AUDIO_ENCODING_NONE () {(0);}' unless defined(&AUDIO_ENCODING_NONE);
    eval 'sub AUDIO_ENCODING_ULAW () {(1);}' unless defined(&AUDIO_ENCODING_ULAW);
    eval 'sub AUDIO_ENCODING_ALAW () {(2);}' unless defined(&AUDIO_ENCODING_ALAW);
    eval 'sub AUDIO_ENCODING_LINEAR () {(3);}' unless defined(&AUDIO_ENCODING_LINEAR);
    eval 'sub AUDIO_ENCODING_FLOAT () {(4);}' unless defined(&AUDIO_ENCODING_FLOAT);
    eval 'sub AUDIO_ENCODING_DVI () {(104);}' unless defined(&AUDIO_ENCODING_DVI);
    eval 'sub AUDIO_ENCODING_LINEAR8 () {(105);}' unless defined(&AUDIO_ENCODING_LINEAR8);
    eval 'sub AUDIO_ENCODING_LINEARLE () {(106);}' unless defined(&AUDIO_ENCODING_LINEARLE);
    eval 'sub AUDIO_MIN_GAIN () {(0);}' unless defined(&AUDIO_MIN_GAIN);
    eval 'sub AUDIO_MAX_GAIN () {(255);}' unless defined(&AUDIO_MAX_GAIN);
    eval 'sub AUDIO_LEFT_BALANCE () {(0);}' unless defined(&AUDIO_LEFT_BALANCE);
    eval 'sub AUDIO_MID_BALANCE () {(32);}' unless defined(&AUDIO_MID_BALANCE);
    eval 'sub AUDIO_RIGHT_BALANCE () {(64);}' unless defined(&AUDIO_RIGHT_BALANCE);
    eval 'sub AUDIO_BALANCE_SHIFT () {(3);}' unless defined(&AUDIO_BALANCE_SHIFT);
    eval 'sub AUDIO_MIN_PLAY_CHANNELS () {(1);}' unless defined(&AUDIO_MIN_PLAY_CHANNELS);
    eval 'sub AUDIO_MAX_PLAY_CHANNELS () {(4);}' unless defined(&AUDIO_MAX_PLAY_CHANNELS);
    eval 'sub AUDIO_MIN_REC_CHANNELS () {(1);}' unless defined(&AUDIO_MIN_REC_CHANNELS);
    eval 'sub AUDIO_MAX_REC_CHANNELS () {(4);}' unless defined(&AUDIO_MAX_REC_CHANNELS);
    eval 'sub AUDIO_MIN_PLAY_PRECISION () {(8);}' unless defined(&AUDIO_MIN_PLAY_PRECISION);
    eval 'sub AUDIO_MAX_PLAY_PRECISION () {(32);}' unless defined(&AUDIO_MAX_PLAY_PRECISION);
    eval 'sub AUDIO_MIN_REC_PRECISION () {(8);}' unless defined(&AUDIO_MIN_REC_PRECISION);
    eval 'sub AUDIO_MAX_REC_PRECISION () {(32);}' unless defined(&AUDIO_MAX_REC_PRECISION);
    eval 'sub AUDIO_SPEAKER () {0x1;}' unless defined(&AUDIO_SPEAKER);
    eval 'sub AUDIO_HEADPHONE () {0x2;}' unless defined(&AUDIO_HEADPHONE);
    eval 'sub AUDIO_LINE_OUT () {0x4;}' unless defined(&AUDIO_LINE_OUT);
    eval 'sub AUDIO_MICROPHONE () {0x1;}' unless defined(&AUDIO_MICROPHONE);
    eval 'sub AUDIO_LINE_IN () {0x2;}' unless defined(&AUDIO_LINE_IN);
    eval 'sub AUDIO_CD () {0x4;}' unless defined(&AUDIO_CD);
    eval 'sub AUDIO_INTERNAL_CD_IN () { &AUDIO_CD;}' unless defined(&AUDIO_INTERNAL_CD_IN);
    eval 'sub AUDIO_ANALOG_LOOPBACK () {0x40;}' unless defined(&AUDIO_ANALOG_LOOPBACK);
    eval 'sub AUDIO_INITINFO {
        local($i) = @_;
	    eval q({ \'unsigned int\' * &__x__;  &for ( &__x__ = ;  &__x__ < ((($i)) + $sizeof{ &audio_info_t}); * &__x__++ = ~0); });
    }' unless defined(&AUDIO_INITINFO);
    eval 'sub AUD_INITVALUE () {(~0);}' unless defined(&AUD_INITVALUE);
    eval 'sub Modify {
        local($X) = @_;
	    eval q((($X) !=  &AUD_INITVALUE));
    }' unless defined(&Modify);
    eval 'sub Modifys {
        local($X) = @_;
	    eval q(( !=  &AUD_INITVALUE));
    }' unless defined(&Modifys);
    eval 'sub Modifyc {
        local($X) = @_;
	    eval q(( !=  &AUD_INITVALUE));
    }' unless defined(&Modifyc);
    eval 'sub MAX_AUDIO_DEV_LEN () {(16);}' unless defined(&MAX_AUDIO_DEV_LEN);
    eval 'sub AUDIO_GETINFO () { &_IOR(ord(\'A\'), 1,  &audio_info_t);}' unless defined(&AUDIO_GETINFO);
    eval 'sub AUDIO_SETINFO () { &_IOWR(ord(\'A\'), 2,  &audio_info_t);}' unless defined(&AUDIO_SETINFO);
    eval 'sub AUDIO_DRAIN () { &_IO(ord(\'A\'), 3);}' unless defined(&AUDIO_DRAIN);
    eval 'sub AUDIO_GETDEV () { &_IOR(ord(\'A\'), 4,  &audio_device_t);}' unless defined(&AUDIO_GETDEV);
    eval 'sub AUDIO_GETDEV_SUNOS () { &_IOR(ord(\'A\'), 4, \'int\');}' unless defined(&AUDIO_GETDEV_SUNOS);
    eval 'sub AUDIO_FLUSH () { &_IO(ord(\'A\'), 5);}' unless defined(&AUDIO_FLUSH);
    eval 'sub AUDIO_DEV_UNKNOWN () {(0);}' unless defined(&AUDIO_DEV_UNKNOWN);
    eval 'sub AUDIO_DEV_AMD () {(1);}' unless defined(&AUDIO_DEV_AMD);
    eval 'sub AUDIO_DEV_SPEAKERBOX () {(2);}' unless defined(&AUDIO_DEV_SPEAKERBOX);
    eval 'sub AUDIO_DEV_CODEC () {(3);}' unless defined(&AUDIO_DEV_CODEC);
    eval 'sub AUDIO_DEV_CS4231 () {(5);}' unless defined(&AUDIO_DEV_CS4231);
    eval 'sub AUDIO_DIAG_LOOPBACK () { &_IOW(ord(\'A\'), 101, \'int\');}' unless defined(&AUDIO_DIAG_LOOPBACK);
    if(defined(&__KERNEL__)) {
	require 'linux/fs.ph';
	require 'linux/tqueue.ph';
	require 'linux/wait.ph';
	eval 'sub SDF_OPEN_WRITE () {0x1;}' unless defined(&SDF_OPEN_WRITE);
	eval 'sub SDF_OPEN_READ () {0x2;}' unless defined(&SDF_OPEN_READ);
    }
    eval 'sub SPARCAUDIO_MIXER_MINOR () {0;}' unless defined(&SPARCAUDIO_MIXER_MINOR);
    eval 'sub SPARCAUDIO_DSP_MINOR () {3;}' unless defined(&SPARCAUDIO_DSP_MINOR);
    eval 'sub SPARCAUDIO_AUDIO_MINOR () {4;}' unless defined(&SPARCAUDIO_AUDIO_MINOR);
    eval 'sub SPARCAUDIO_DSP16_MINOR () {5;}' unless defined(&SPARCAUDIO_DSP16_MINOR);
    eval 'sub SPARCAUDIO_STATUS_MINOR () {6;}' unless defined(&SPARCAUDIO_STATUS_MINOR);
    eval 'sub SPARCAUDIO_AUDIOCTL_MINOR () {7;}' unless defined(&SPARCAUDIO_AUDIOCTL_MINOR);
    eval 'sub SPARCAUDIO_DEVICE_SHIFT () {4;}' unless defined(&SPARCAUDIO_DEVICE_SHIFT);
    eval 'sub SPARCAUDIO_MAX_DEVICES () {3;}' unless defined(&SPARCAUDIO_MAX_DEVICES);
    eval 'sub I_NREAD () { &_IOR(ord(\'S\'),01, \'int\');}' unless defined(&I_NREAD);
    eval 'sub I_NREAD_SOLARIS () {((ord(\'S\')<<8)|1);}' unless defined(&I_NREAD_SOLARIS);
    eval 'sub I_FLUSH () { &_IO(ord(\'S\'),05);}' unless defined(&I_FLUSH);
    eval 'sub I_FLUSH_SOLARIS () {((ord(\'S\')<<8)|5);}' unless defined(&I_FLUSH_SOLARIS);
    eval 'sub FLUSHR () {1;}' unless defined(&FLUSHR);
    eval 'sub FLUSHW () {2;}' unless defined(&FLUSHW);
    eval 'sub FLUSHRW () {3;}' unless defined(&FLUSHRW);
    eval 'sub I_SETSIG () { &_IO(ord(\'S\'),011);}' unless defined(&I_SETSIG);
    eval 'sub I_SETSIG_SOLARIS () {((ord(\'S\')<<8)|11);}' unless defined(&I_SETSIG_SOLARIS);
    eval 'sub S_INPUT () {0x1;}' unless defined(&S_INPUT);
    eval 'sub S_HIPRI () {0x2;}' unless defined(&S_HIPRI);
    eval 'sub S_OUTPUT () {0x4;}' unless defined(&S_OUTPUT);
    eval 'sub S_MSG () {0x8;}' unless defined(&S_MSG);
    eval 'sub S_ERROR () {0x10;}' unless defined(&S_ERROR);
    eval 'sub S_HANGUP () {0x20;}' unless defined(&S_HANGUP);
    eval 'sub S_RDNORM () {0x40;}' unless defined(&S_RDNORM);
    eval 'sub S_WRNORM () { &S_OUTPUT;}' unless defined(&S_WRNORM);
    eval 'sub S_RDBAND () {0x80;}' unless defined(&S_RDBAND);
    eval 'sub S_WRBAND () {0x100;}' unless defined(&S_WRBAND);
    eval 'sub S_BANDURG () {0x200;}' unless defined(&S_BANDURG);
    eval 'sub S_ALL () {0x3ff;}' unless defined(&S_ALL);
    eval 'sub I_GETSIG () { &_IOR(ord(\'S\'),012,\'int\');}' unless defined(&I_GETSIG);
    eval 'sub I_GETSIG_SOLARIS () {((ord(\'S\')<<8)|12);}' unless defined(&I_GETSIG_SOLARIS);
    eval 'sub OSS_RIGHT {
        local($value) = @_;
	    eval q({ ((($value >> 8) & 0xff) % 101); });
    }' unless defined(&OSS_RIGHT);
    eval 'sub O_TO_S {
        local($value) = @_;
	    eval q({ $value * 255/ 100; });
    }' unless defined(&O_TO_S);
    eval 'sub S_TO_O {
        local($value) = @_;
	    eval q({ $value * 100/ 255; });
    }' unless defined(&S_TO_O);
    eval 'sub OSS_TO_GAIN {
        local($value) = @_;
	    eval q({ \'int\'  &l =  &O_TO_S( &OSS_LEFT($value)); \'int\'  &r =  &O_TO_S( &OSS_RIGHT($value)); (( &l >  &r) ?  &l :  &r); });
    }' unless defined(&OSS_TO_GAIN);
    eval 'sub OSS_TO_LGAIN {
        local($value) = @_;
	    eval q({ \'int\'  &l =  &O_TO_S( &OSS_LEFT($value)); \'int\'  &r =  &O_TO_S( &OSS_RIGHT($value)); (( &l <  &r) ?  &l :  &r); });
    }' unless defined(&OSS_TO_LGAIN);
    eval 'sub OSS_TO_BAL {
        local($value) = @_;
	    eval q({  &if (! &OSS_TO_GAIN($value))  &AUDIO_MID_BALANCE;  &if (! &OSS_TO_LGAIN($value)) {  &if ( &OSS_TO_GAIN($value) ==  &OSS_TO_GAIN( &OSS_RIGHT($value)))  &AUDIO_RIGHT_BALANCE;  &else  &AUDIO_LEFT_BALANCE; }  &if ( &OSS_TO_GAIN($value) ==  &OSS_TO_GAIN( &OSS_RIGHT($value))) (( &OSS_TO_GAIN($value) -  &OSS_TO_LGAIN($value)) >>  &AUDIO_BALANCE_SHIFT) +  &AUDIO_MID_BALANCE;  &else  &AUDIO_MID_BALANCE - (( &OSS_TO_GAIN($value) -  &OSS_TO_LGAIN($value)) >>  &AUDIO_BALANCE_SHIFT); });
    }' unless defined(&OSS_TO_BAL);
    eval 'sub BAL_TO_OSS {
        local($value,$balance) = @_;
	    eval q({ \'int\'  &l,  &r,  &adj;  &if ($balance > 63) $balance = 63;  &if ($balance <  &AUDIO_MID_BALANCE) {  &l = $value * 100/ 255+ (($value * 100% 255) > 0);  &adj = (( &AUDIO_MID_BALANCE - $balance) <<  &AUDIO_BALANCE_SHIFT);  &if ( &adj < $value)  &r = ($value -  &adj) * 100/ 255;  &else  &r = 0; }  &else  &if ($balance >  &AUDIO_MID_BALANCE) {  &r = $value * 100/ 255+ (($value * 100% 255) > 0);  &adj = (($balance -  &AUDIO_MID_BALANCE) <<  &AUDIO_BALANCE_SHIFT);  &if ( &adj < $value)  &l = ($value -  &adj) * 100/ 255;  &else  &l = 0; }  &else {  &l =  &r = $value * 100/ 255+ (($value * 100% 255) > 0); } (( &r << 8) +  &l); });
    }' unless defined(&BAL_TO_OSS);
    if(defined(&__KERNEL__)) {
	eval 'sub OSS_TWIDDLE_PORT {
	    local($drv,$ioctl,$port,$set,$value) = @_;
    	    eval q({  &if ($ioctl == $port) { \'int\'  &p;  &if ( ($drv->{ops}->{get_output_port})  &&  ($drv->{ops}->{set_output_port})) {  &p =  ($drv->{ops}->{get_output_port})($drv);  &if (($value == 0) || (( &p & $set)  && ( &OSS_LEFT($value) < 100)))  ($drv->{ops}->{set_output_port})($drv,  &p & ~($set));  &else  ($drv->{ops}->{set_output_port})($drv,  &p | $set); } } });
	}' unless defined(&OSS_TWIDDLE_PORT);
	eval 'sub OSS_TWIDDLE_IPORT {
	    local($drv,$ioctl,$port,$set,$value) = @_;
    	    eval q({  &if ($ioctl == $port) { \'int\'  &p;  &if ( ($drv->{ops}->{get_input_port})  &&  ($drv->{ops}->{set_input_port})) {  &p =  ($drv->{ops}->{get_input_port})($drv);  &if (($value == 0) || (( &p & $set)  && ( &OSS_LEFT($value) < 100)))  ($drv->{ops}->{set_input_port})($drv,  &p & ~($set));  &else  ($drv->{ops}->{set_input_port})($drv,  &p | $set); } } });
	}' unless defined(&OSS_TWIDDLE_IPORT);
    }
}
1;
