require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SPARC_OBIO_H)) {
    eval 'sub _SPARC_OBIO_H () {1;}' unless defined(&_SPARC_OBIO_H);
    require 'asm/asi.ph';
    eval 'sub CSR_BASE_ADDR () {0xe0000000;}' unless defined(&CSR_BASE_ADDR);
    eval 'sub CSR_CPU_SHIFT () {(32- 4- 5);}' unless defined(&CSR_CPU_SHIFT);
    eval 'sub CSR_XDBUS_SHIFT () {8;}' unless defined(&CSR_XDBUS_SHIFT);
    eval 'sub CSR_BASE {
        local($cpu) = @_;
	    eval q(((( &CSR_BASE_ADDR >>  &CSR_CPU_SHIFT) + $cpu) <<  &CSR_CPU_SHIFT));
    }' unless defined(&CSR_BASE);
    eval 'sub ECSR_BASE_ADDR () {0x;}' unless defined(&ECSR_BASE_ADDR);
    eval 'sub ECSR_CPU_SHIFT () {(32- 5);}' unless defined(&ECSR_CPU_SHIFT);
    eval 'sub ECSR_DEV_SHIFT () {(32- 8);}' unless defined(&ECSR_DEV_SHIFT);
    eval 'sub ECSR_BASE {
        local($cpu) = @_;
	    eval q((($cpu) <<  &ECSR_CPU_SHIFT));
    }' unless defined(&ECSR_BASE);
    eval 'sub ECSR_DEV_BASE {
        local($devid) = @_;
	    eval q((($devid) <<  &ECSR_DEV_SHIFT));
    }' unless defined(&ECSR_DEV_BASE);
    eval 'sub BW_LOCAL_BASE () {0xfff00000;}' unless defined(&BW_LOCAL_BASE);
    eval 'sub BW_CID () {0x;}' unless defined(&BW_CID);
    eval 'sub BW_DBUS_CTRL () {0x8;}' unless defined(&BW_DBUS_CTRL);
    eval 'sub BW_DBUS_DATA () {0x10;}' unless defined(&BW_DBUS_DATA);
    eval 'sub BW_CTRL () {0x1000;}' unless defined(&BW_CTRL);
    eval 'sub BW_INTR_TABLE () {0x1040;}' unless defined(&BW_INTR_TABLE);
    eval 'sub BW_INTR_TABLE_CLEAR () {0x1080;}' unless defined(&BW_INTR_TABLE_CLEAR);
    eval 'sub BW_PRESCALER () {0x10c0;}' unless defined(&BW_PRESCALER);
    eval 'sub BW_PTIMER_LIMIT () {0x2000;}' unless defined(&BW_PTIMER_LIMIT);
    eval 'sub BW_PTIMER_COUNTER2 () {0x2004;}' unless defined(&BW_PTIMER_COUNTER2);
    eval 'sub BW_PTIMER_NDLIMIT () {0x2008;}' unless defined(&BW_PTIMER_NDLIMIT);
    eval 'sub BW_PTIMER_CTRL () {0x200c;}' unless defined(&BW_PTIMER_CTRL);
    eval 'sub BW_PTIMER_COUNTER () {0x2010;}' unless defined(&BW_PTIMER_COUNTER);
    eval 'sub BW_TIMER_LIMIT () {0x3000;}' unless defined(&BW_TIMER_LIMIT);
    eval 'sub BW_TIMER_COUNTER2 () {0x3004;}' unless defined(&BW_TIMER_COUNTER2);
    eval 'sub BW_TIMER_NDLIMIT () {0x3008;}' unless defined(&BW_TIMER_NDLIMIT);
    eval 'sub BW_TIMER_CTRL () {0x300c;}' unless defined(&BW_TIMER_CTRL);
    eval 'sub BW_TIMER_COUNTER () {0x3010;}' unless defined(&BW_TIMER_COUNTER);
    eval 'sub BW_CTRL_USER_TIMER () {0x4;}' unless defined(&BW_CTRL_USER_TIMER);
    eval 'sub BB_LOCAL_BASE () {0xf0000000;}' unless defined(&BB_LOCAL_BASE);
    eval 'sub BB_STAT1 () {0x100000;}' unless defined(&BB_STAT1);
    eval 'sub BB_STAT2 () {0x120000;}' unless defined(&BB_STAT2);
    eval 'sub BB_STAT3 () {0x140000;}' unless defined(&BB_STAT3);
    eval 'sub BB_LEDS () {0x2e0000;}' unless defined(&BB_LEDS);
    eval 'sub BB_STAT2_AC_INTR () {0x4;}' unless defined(&BB_STAT2_AC_INTR);
    eval 'sub BB_STAT2_TMP_INTR () {0x10;}' unless defined(&BB_STAT2_TMP_INTR);
    eval 'sub BB_STAT2_FAN_INTR () {0x20;}' unless defined(&BB_STAT2_FAN_INTR);
    eval 'sub BB_STAT2_PWR_INTR () {0x40;}' unless defined(&BB_STAT2_PWR_INTR);
    eval 'sub BB_STAT2_MASK () {( &BB_STAT2_AC_INTR| &BB_STAT2_TMP_INTR| &BB_STAT2_FAN_INTR| &BB_STAT2_PWR_INTR);}' unless defined(&BB_STAT2_MASK);
    eval 'sub CC_BASE () {0x1f00000;}' unless defined(&CC_BASE);
    eval 'sub CC_DATSTREAM () {0x1f00000;}' unless defined(&CC_DATSTREAM);
    eval 'sub CC_DATSIZE () {0x1f0003f;}' unless defined(&CC_DATSIZE);
    eval 'sub CC_SRCSTREAM () {0x1f00100;}' unless defined(&CC_SRCSTREAM);
    eval 'sub CC_DESSTREAM () {0x1f00200;}' unless defined(&CC_DESSTREAM);
    eval 'sub CC_RMCOUNT () {0x1f00300;}' unless defined(&CC_RMCOUNT);
    eval 'sub CC_IPEN () {0x1f00406;}' unless defined(&CC_IPEN);
    eval 'sub CC_IMSK () {0x1f00506;}' unless defined(&CC_IMSK);
    eval 'sub CC_ICLR () {0x1f00606;}' unless defined(&CC_ICLR);
    eval 'sub CC_IGEN () {0x1f00704;}' unless defined(&CC_IGEN);
    eval 'sub CC_STEST () {0x1f00804;}' unless defined(&CC_STEST);
    eval 'sub CC_CREG () {0x1f00a04;}' unless defined(&CC_CREG);
    eval 'sub CC_SREG () {0x1f00b00;}' unless defined(&CC_SREG);
    eval 'sub CC_RREG () {0x1f00c04;}' unless defined(&CC_RREG);
    eval 'sub CC_EREG () {0x1f00e00;}' unless defined(&CC_EREG);
    eval 'sub CC_CID () {0x1f00f04;}' unless defined(&CC_CID);
    unless(defined(&__ASSEMBLY__)) {
	eval 'sub bw_get_intr_mask {
	    local($sbus_level) = @_;
    	    eval q({ \'int\'  &mask;  &__asm__  &__volatile__ (\\"lduha [%1] %2, %0\\" : \\"=r\\" ( &mask) : \\"r\\" ( &BW_LOCAL_BASE +  &BW_INTR_TABLE + ($sbus_level << 3)), \\"i\\" ( &ASI_M_CTL));  &mask; });
	}' unless defined(&bw_get_intr_mask);
	eval 'sub bw_clear_intr_mask {
	    local($sbus_level,$mask) = @_;
    	    eval q({  &__asm__  &__volatile__ (\\"stha %0, [%1] %2\\" : : \\"r\\" ($mask), \\"r\\" ( &BW_LOCAL_BASE +  &BW_INTR_TABLE_CLEAR + ($sbus_level << 3)), \\"i\\" ( &ASI_M_CTL)); });
	}' unless defined(&bw_clear_intr_mask);
	eval 'sub bw_get_prof_limit {
	    local($cpu) = @_;
    	    eval q({ my $limit;  &__asm__  &__volatile__ (\\"lda [%1] %2, %0\\" : \\"=r\\" ( $limit) : \\"r\\" ( &CSR_BASE($cpu) +  &BW_PTIMER_LIMIT), \\"i\\" ( &ASI_M_CTL));  $limit; });
	}' unless defined(&bw_get_prof_limit);
	eval 'sub bw_set_prof_limit {
	    local($cpu,$limit) = @_;
    	    eval q({  &__asm__  &__volatile__ (\\"sta %0, [%1] %2\\" : : \\"r\\" ($limit), \\"r\\" ( &CSR_BASE($cpu) +  &BW_PTIMER_LIMIT), \\"i\\" ( &ASI_M_CTL)); });
	}' unless defined(&bw_set_prof_limit);
	eval 'sub bw_get_ctrl {
	    local($cpu) = @_;
    	    eval q({ my $ctrl;  &__asm__  &__volatile__ (\\"lda [%1] %2, %0\\" : \\"=r\\" ( $ctrl) : \\"r\\" ( &CSR_BASE($cpu) +  &BW_CTRL), \\"i\\" ( &ASI_M_CTL));  $ctrl; });
	}' unless defined(&bw_get_ctrl);
	eval 'sub bw_set_ctrl {
	    local($cpu,$ctrl) = @_;
    	    eval q({  &__asm__  &__volatile__ (\\"sta %0, [%1] %2\\" : : \\"r\\" ($ctrl), \\"r\\" ( &CSR_BASE($cpu) +  &BW_CTRL), \\"i\\" ( &ASI_M_CTL)); });
	}' unless defined(&bw_set_ctrl);
	eval 'sub show_leds {
	    local($cpuid) = @_;
    	    eval q({ $cpuid &= 0x1e;  &__asm__  &__volatile__ (\\"stba %0, [%1] %2\\" : : \\"r\\" (( $cpu_leds[$cpuid] << 4) |  $cpu_leds[$cpuid+1]), \\"r\\" ( &ECSR_BASE($cpuid) |  &BB_LEDS), \\"i\\" ( &ASI_M_CTL)); });
	}' unless defined(&show_leds);
	eval 'sub cc_get_ipen {
	    local($void) = @_;
    	    eval q({ my $pending;  &__asm__  &__volatile__ (\\"lduha [%1] %2, %0\\" : \\"=r\\" ( $pending) : \\"r\\" ( &CC_IPEN), \\"i\\" ( &ASI_M_MXCC));  $pending; });
	}' unless defined(&cc_get_ipen);
	eval 'sub cc_set_iclr {
	    local($clear) = @_;
    	    eval q({  &__asm__  &__volatile__ (\\"stha %0, [%1] %2\\" : : \\"r\\" ($clear), \\"r\\" ( &CC_ICLR), \\"i\\" ( &ASI_M_MXCC)); });
	}' unless defined(&cc_set_iclr);
	eval 'sub cc_get_imsk {
	    local($void) = @_;
    	    eval q({ my $mask;  &__asm__  &__volatile__ (\\"lduha [%1] %2, %0\\" : \\"=r\\" ( $mask) : \\"r\\" ( &CC_IMSK), \\"i\\" ( &ASI_M_MXCC));  $mask; });
	}' unless defined(&cc_get_imsk);
	eval 'sub cc_set_imsk {
	    local($mask) = @_;
    	    eval q({  &__asm__  &__volatile__ (\\"stha %0, [%1] %2\\" : : \\"r\\" ($mask), \\"r\\" ( &CC_IMSK), \\"i\\" ( &ASI_M_MXCC)); });
	}' unless defined(&cc_set_imsk);
	eval 'sub cc_get_imsk_other {
	    local($cpuid) = @_;
    	    eval q({ my $mask;  &__asm__  &__volatile__ (\\"lduha [%1] %2, %0\\" : \\"=r\\" ( $mask) : \\"r\\" ( &ECSR_BASE($cpuid) |  &CC_IMSK), \\"i\\" ( &ASI_M_CTL));  $mask; });
	}' unless defined(&cc_get_imsk_other);
	eval 'sub cc_set_imsk_other {
	    local($cpuid,$mask) = @_;
    	    eval q({  &__asm__  &__volatile__ (\\"stha %0, [%1] %2\\" : : \\"r\\" ($mask), \\"r\\" ( &ECSR_BASE($cpuid) |  &CC_IMSK), \\"i\\" ( &ASI_M_CTL)); });
	}' unless defined(&cc_set_imsk_other);
	eval 'sub cc_set_igen {
	    local($gen) = @_;
    	    eval q({  &__asm__  &__volatile__ (\\"sta %0, [%1] %2\\" : : \\"r\\" ($gen), \\"r\\" ( &CC_IGEN), \\"i\\" ( &ASI_M_MXCC)); });
	}' unless defined(&cc_set_igen);
	eval 'sub IGEN_MESSAGE {
	    local($bcast, $devid, $sid, $levels) = @_;
    	    eval q(((($bcast) << 31) | (($devid) << 23) | (($sid) << 15) | ($levels)));
	}' unless defined(&IGEN_MESSAGE);
    }
}
1;
